<template>
  <b-modal
    ref="theModal"
    :title="modalTitle"
    size="xl"
    no-close-on-backdrop
    no-close-on-esc
    hide-header-close
  >
    <b-form @submit.prevent="onSave">
      <b-form-group label="Type">
        <b-form-select
          v-model="form.type"
          :options="typeOptions"
        ></b-form-select>
      </b-form-group>

      <b-form-group label="Template name">
        <b-form-input v-model="form.name" trim></b-form-input>
      </b-form-group>

      <b-form-group label="Slug / Access key">
        <b-form-input
          v-model="form.slug"
          :disabled="editMode"
          trim
        ></b-form-input>
      </b-form-group>

      <b-form-group label="Default language">
        <b-form-input
          v-model="form.defaultLanguage"
          style="width:75px;"
          trim
        ></b-form-input>
      </b-form-group>

      <b-form-group label="Enabled languages">
        <div v-for="lang in form.enabledLanguages" class="mb-2">
          <b-badge variant="light" style="font-size: medium;">
            {{ lang }}
          </b-badge>
          <b-button @click="removeLang(lang)" variant="danger" size="sm">
            <font-awesome-icon :icon="['fas', 'times']" />
          </b-button>
        </div>
        <div class="d-flex">
          <b-form-input
            v-model="addLangValue"
            style="width:75px;"
            trim
          ></b-form-input>
          <b-button
            @click="addLang"
            :disabled="!addLangEntered"
            variant="info"
            class="ml-2"
          >
            <font-awesome-icon :icon="['fas', 'plus']" />
          </b-button>
        </div>
      </b-form-group>
    </b-form>

    <template v-slot:modal-footer>
      <b-button @click="onCancel" variant="danger">CANCEL</b-button>
      <b-button
        @click="onSave"
        :disabled="!validForm"
        variant="success"
        class="ml-2"
        >SAVE</b-button
      >
    </template>
  </b-modal>
</template>

<script>
export default {
  data() {
    return {
      entry: null,
      defaultForm: {
        type: 'SITE',
        name: '',
        slug: '',
        defaultLanguage: '',
        enabledLanguages: [],
      },
      form: {
        type: 'SITE',
        name: '',
        slug: '',
        defaultLanguage: '',
        enabledLanguages: [],
      },
      typeOptions: ['SITE', 'EMAIL', 'PDF'],
      addLangValue: '',
    };
  },
  computed: {
    addLangEntered() {
      return !!this.addLangValue && this.addLangValue !== '';
    },
    modalTitle() {
      if (this.editMode) {
        return 'Edit Template';
      }

      return 'New Template';
    },
    editMode() {
      return !!this.entry;
    },
    validForm() {
      return (
        this.form.name !== '' &&
        this.form.slug !== '' &&
        this.form.defaultLanguage !== '' &&
        this.form.enabledLanguages.length > 0 &&
        this.form.enabledLanguages.some((entry) => {
          if (entry === this.form.defaultLanguage) {
            return true;
          }
        })
      );
    },
  },
  methods: {
    removeLang(lang) {
      this.form.enabledLanguages = this.form.enabledLanguages.filter(
        (entry) => {
          if (entry !== lang) {
            return true;
          }
        }
      );
    },
    addLang() {
      this.form.enabledLanguages.push(this.addLangValue);
      this.addLangValue = '';
    },
    show(template) {
      this.entry = template;

      if (this.entry) {
        this.form = JSON.parse(JSON.stringify(template));
      } else {
        this.form = JSON.parse(JSON.stringify(this.defaultForm));
      }

      this.addLangValue = '';

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
    onCancel() {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: true })
        .then((value) => {
          if (value === true) {
            this.hide();
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    onSave() {
      this.$emit('save', this.form);
      this.hide();
    },
  },
};
</script>
